lab_1/urls.py
from django.urls import path
from .views import index, friend_list

urlpatterns = [
    path('', index, name='index'),
    path('friends/', friend_list, name='friend_list')
    # TODO Add friends path using friend_list Views
]

lab_2/urls.py
from django.urls import path
from .views import index, xml, json

urlpatterns = [
    path('', index, name='index'),
    path('xml/', xml, name='xml'),
    path('json/', json, name='json')
]

lab_3/urls.py
from django.urls import path
from .views import add_friend, index

urlpatterns = [
    path('', index, name='index'),
    path('add/', add_friend, name='add')
]

lab_4/urls.py
from django.urls import path
from .views import index, add_note, note_list

urlpatterns = [
    path('', index, name='index'),
    path('add-note/', add_note, name='add'),
    path('note-list/', note_list, name='note-list')
]

praktikum/urls.py
from django import urls
from django.urls import path, re_path, include
from django.contrib import admin
import lab_1.urls as lab_1
from lab_1.views import index as index_lab1

urlpatterns = [
    path('admin/', admin.site.urls),
    path('lab-1/', include('lab_1.urls')),
    path('lab-2/', include('lab_2.urls')),
    path('lab-3/', include('lab_3.urls')),
    path('lab-4/', include('lab_4.urls')),
    re_path(r'^$', index_lab1, name='index')
]

lab_1/models.py
from django.db import models

# TODO Create Friend model that contains name, npm, and DOB (date of birth) here


class Friend(models.Model):
    name = models.CharField(max_length=30)
    npm = models.CharField(max_length=10)
    birth_date = models.DateField(max_length=40)
    # TODO Implement missing attributes in Friend model

lab_2/models.py
from django.db import models

# Create your models here.
class Note(models.Model):
    to = models.CharField(max_length=30)
    froms = models.CharField(max_length=30)
    title = models.CharField(max_length=30)
    message = models.CharField(max_length=120)

lab_3/models.py
from django.db import models

# Create your models here.

lab_4/models.py
from django.db import models

# Create your models here.

lab_3/forms.py
from django import forms
from django.db.models import fields

from lab_1.models import Friend

class FriendForm(forms.ModelForm):
    class Meta:
        model = Friend
        fields = '__all__'

    # input_attrs1 = {
	# 	'type' : 'text',
	# 	'placeholder' : 'Nama Kamu'
	# }

    # input_attrs2 = {
	# 	'type' : 'text',
	# 	'placeholder' : 'Nama Kamu'
	# }

    # input_attrs3 = {
	# 	'type' : 'date',
	# }

    # name = forms.CharField(label='',required=False,max_length=30,widget=forms.TextInput(attrs=input_attrs1))
    # npm = forms.CharField(label='',required=False, max_length=30, widget=forms.TextInput(attrs=input_attrs2))
    # birth_date= forms.DateField(label='',required=False, widget=forms.TextInput(attrs=input_attrs3))

lab_4/forms.py
from django import forms
from django.db.models import fields
from lab_2.models import Note

class NoteForm(forms.ModelForm):
    class Meta:
        model = Note
        fields = '__all__'

lab_1/views.py
from django.shortcuts import render
from datetime import datetime, date
from .models import Friend

mhs_name = 'Judah Ariesaka Magaini'  # TODO Implement this
curr_year = int(datetime.now().strftime("%Y"))
birth_date = date(2002, 4, 12)  # TODO Implement this, format (Year, Month, Date)
npm = 2006463042  # TODO Implement this


def index(request):
    response = {'name': mhs_name,
                'age': calculate_age(birth_date.year),
                'npm': npm}
    return render(request, 'index_lab1.html', response)


def calculate_age(birth_year):
    return curr_year - birth_year if birth_year <= curr_year else 0


def friend_list(request):
    friends =  Friend.objects.all().values()# TODO Implement this
    response = {'friends': friends}
    return render(request, 'friend_list_lab1.html', response)

lab_2/views.py
from django.shortcuts import render
from .models import Note
from django.http.response import HttpResponse
from django.core import serializers

# Create your views here.
def index(request):
    notes = Note.objects.all().values()
    response = {'notes': notes}
    return render(request, 'lab2.html', response)

def xml(request):
    data = serializers.serialize('xml', Note.objects.all())
    return HttpResponse(data, content_type="application/xml")

def json(request):
    data = serializers.serialize('json', Note.objects.all())
    return HttpResponse(data, content_type="application/json")

lab_3/views.py
from django.shortcuts import render
from django.http import HttpResponseRedirect
from django.contrib.auth.decorators import login_required
from lab_1.models import Friend
from .forms import FriendForm

# Create your views here.
@login_required(login_url='/admin/login/')
def index(request):
    friends = Friend.objects.all().values()
    response = {'friends': friends}
    return render(request, 'lab3_index.html', response)

@login_required(login_url='/admin/login/')
def add_friend(request):
    form = FriendForm(request.POST or None)
    if (form.is_valid() and request.method == 'POST'):
        form.save()
        return HttpResponseRedirect('/lab-3')
    
    return render(request, 'lab3_form.html', {'form': form})

lab_4/views.py
from django.shortcuts import render
from django.http import HttpResponseRedirect
from lab_2.models import Note
from .forms import NoteForm


# Create your views here.
def index(request):
    notes = Note.objects.all().values()
    response = {'notes': notes}
    return render(request, 'lab4_index.html', response)


def add_note(request):
    form = NoteForm(request.POST or None)
    if form.is_valid() and request.method == 'POST':
        form.save()
        return HttpResponseRedirect('/lab-4')

    return render(request, 'lab4_form.html', {'form': form})


def note_list(request):
    notes = Note.objects.all().values()
    response = {'notes': notes}
    return render(request, 'lab4_note_list.html', response)

lab_1/templates/friend_list_lab1.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Friend List</title>
  </head>
  <body>
    <table>
      <tr>
        <th>Name</th>
        <th>NPM</th>
        <th>DOB</th>
      </tr>
      {% if friends %}
        {% for friend in friends %}
          <tr>
            <td>{{ friend.name }}</td>
            <td>{{ friend.npm }}</td>
            <td>{{ friend.birth_date }}</td>
          </tr>
        {% endfor %}
      {% endif %}
      <!-- TODO loop from Friend model -->
      <!-- EXAMPLE SECTION -->
      <tr>
        <td>Asmara Nugi</td>
        <td>1706032156</td>
        <td>May 1, 1999</td>
      </tr>
      <tr>
        <td>Fadli Rais</td>
        <td>1706032370</td>
        <td>Sept 11, 1998</td>
      </tr>
      <!-- END SECTION -->
    </table>
  </body>
</html>

lab_1/templates/index_lab1.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>{{ name }}</title>
  </head>
  <body>
    <h1>Hello my name is {{ name }}</h1>
    <article>NPM : {{ npm }}</article>
    <article>I am {{ age }} years old</article>
  </body>
</html>

lab_2/templates/lab2.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Friend List</title>
    <!-- https://www.youtube.com/watch?v=Oy9K7iz3aa4&ab_channel=AngelaDelise -->
    <style> 
      body {
        font-family: -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, Oxygen, Ubuntu, Cantarell, 'Open Sans', 'Helvetica Neue', sans-serif;
      }
      
      table {
        border-collapse: collapse;
        box-shadow: 0 5px 10px rgb(218, 218, 218);
      }

      thead {
        box-shadow: 0 5px 10px rgb(214, 214, 214);
      }

      th {
        text-transform: uppercase;
        padding: 1rem 2rem;
      }

      td {
        padding: 1rem 2rem;
      }

      tr:nth-child(even){
        background-color: aquamarine;
      }

    </style>
  </head>
  <body>
    <h1>Note List ✨✨</h1>
    <table>
      <tr>
        <thead>
          <th>To</th>
          <th>From</th>
          <th>Title</th>
          <th>Message</th>
        </thead>
      </tr>
      {% if notes %}
        {% for note in notes %}
          <tr>
            <td>{{ note.to }}</td>
            <td>{{ note.froms }}</td>
            <td>{{ note.title }}</td>
            <td>{{ note.message }}</td>
          </tr>
        {% endfor %}
      {% endif %}
    </table>
  </body>
</html>

lab_3/templates/lab3_form.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Friend List Form</title>
    <!-- https://codepen.io/ainalem/pen/GRqPwoz by Mikail Ainalem-->
    <!-- https://cssgradient.io/ for gradient color -->
    <!-- https://colorhunt.co/palette/2b2e4ae8454590374953354a for color-->
    <style>
      body {
        align-items: center;
        background: rgb(83,53,74);
        background: linear-gradient(90deg, rgba(83,53,74,1) 0%, rgba(144,55,73,1) 50%, rgba(232,69,69,1) 100%);
        display: flex;
        justify-content: center;
        height: 100vh;
        font-family: -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, Oxygen, Ubuntu, Cantarell, 'Open Sans', 'Helvetica Neue', sans-serif;
      }

      form {
        background-color: #2B2E4A;
        border-radius: 20px;
        box-sizing: border-box;
        height: 500px;
        padding: 20px;
        width: 320px;
      }

      .title {
        color: #F4EEFF;
        font-size: 36px;
        font-weight: 800;
        margin-top: 30px;
      }

      .subtitle {
        color: #F4EEFF;
        font-size: 16px;
        font-weight: 600;
        margin-top: 10px;
      }

      .input-container {
        height: 50px;
        position: relative;
        width: 100%;
      }

      .ic1 {
        margin-top: 40px;
      }

      .ic2 {
        margin-top: 30px;
      }

      .input {
        background-color: #F4EEFF;
        border-radius: 12px;
        border: 0;
        box-sizing: border-box;
        color: #65657b;
        font-size: 18px;
        height: 100%;
        outline: 0;
        padding: 4px 20px 0;
        width: 100%;
        font-family: -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, Oxygen, Ubuntu, Cantarell, 'Open Sans', 'Helvetica Neue', sans-serif;
      }

      .cut {
        background-color: #2B2E4A;
        border-radius: 10px;
        height: 20px;
        left: 20px;
        position: absolute;
        top: -20px;
        transform: translateY(0);
        transition: transform 200ms;
        width: 120px;
      }

      .cut-short {
        width: 50px;
      }

      .input:focus ~ .cut,
      .input:not(:placeholder-shown) ~ .cut {
        transform: translateY(8px);
      }

      .placeholder {
        color: #65657b;
        left: 20px;
        line-height: 14px;
        pointer-events: none;
        position: absolute;
        transform-origin: 0 50%;
        transition: transform 200ms, color 200ms;
        top: 20px;
      }

      .input:focus ~ .placeholder,
      .input:not(:placeholder-shown) ~ .placeholder {
        transform: translateY(-30px) translateX(10px) scale(0.75);
      }

      .input:not(:placeholder-shown) ~ .placeholder {
        color: #808097;
      }

      .input:focus ~ .placeholder {
        color: #dc2f55;
      }

      .submit {
        background: rgb(83,53,74);
        background: linear-gradient(90deg, rgba(83,53,74,1) 0%, rgba(144,55,73,1) 50%, rgba(232,69,69,1) 100%);
        border-radius: 12px;
        border: 0;
        box-sizing: border-box;
        color: #F4EEFF;
        cursor: pointer;
        font-size: 18px;
        height: 50px;
        margin-top: 38px;
        outline: 0;
        text-align: center;
        width: 100%;
      }

      input[type="date"] {
        color: #65657b;
        font-family: -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, Oxygen, Ubuntu, Cantarell, 'Open Sans', 'Helvetica Neue', sans-serif;
      }

    </style>
  </head>
  <body>
    <form action="" method="POST">
        {% csrf_token %}
        <div class="title">Friend Form ✨</div>
        <div class="subtitle">Register your new friend!</div>
        <div class="input-container ic1">
          <input class="input" type="text" name="name" maxlength="30" id="id_name" placeholder=" ">
          <div class="cut"></div>
          <label for="name" class="placeholder">Your friend's name</label>
        </div>
        <div class="input-container ic2">
          <input class="input" type="text" name="npm" maxlength="30" id="id_npm" placeholder=" ">
          <div class="cut"></div>
          <label for="npm" class="placeholder">Your friend's NPM</label>
        </div>
        <div class="input-container ic2">
          <input class="input" type="date" name="birth_date" id="id_birth_date">
        </div>
        <input class="submit" type="submit" value="Submit">
    </form>
  </body>
</html>

lab_3/templates/lab3_index.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Friend List</title>
    <!-- https://www.youtube.com/watch?v=Oy9K7iz3aa4&ab_channel=AngelaDelise -->
    <style> 
        body {
          font-family: -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, Oxygen, Ubuntu, Cantarell, 'Open Sans', 'Helvetica Neue', sans-serif;
        }
        
        table {
          border-collapse: collapse;
          box-shadow: 0 5px 10px rgb(218, 218, 218);
        }
  
        thead {
          box-shadow: 0 5px 10px rgb(214, 214, 214);
        }
  
        th {
          text-transform: uppercase;
          padding: 1rem 2rem;
        }
  
        td {
          padding: 1rem 2rem;
        }
  
        tr:nth-child(even){
          background-color: aquamarine;
        }
  
      </style>
  </head>
  <body>
    <h1>Friend List✨🎉</h1>
    <table>
      <tr>
        <th>Name</th>
        <th>NPM</th>
        <th>DOB</th>
      </tr>
      {% if friends %}
        {% for friend in friends %}
          <tr>
            <td>{{ friend.name }}</td>
            <td>{{ friend.npm }}</td>
            <td>{{ friend.birth_date }}</td>
          </tr>
        {% endfor %}
      {% endif %}
    </table>
  </body>
</html>

lab_4/templates/lab4_form.html
{% load static %}
<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8" />
  <title>Write your note!✨</title>
  <link rel="stylesheet" href="{% static 'css/form.css' %}" />
</head>

<body>

  <ul>
    <li><a href="/lab-4">Home</a></li>
    <li><a href="/lab-4/add-note" class="active">Form</a></li>
    <li><a href="/lab-4/note-list">Card</a></li>
  </ul>

  <div class="container">
    <form action="" method="POST">
      {% csrf_token %}

      <p>Send your friend a note!📝📝</p>

      <div class="input-container">
        <input type="text" name="to">
        <div class="cut">Your friend's name</div>
      </div>

      <div class="input-container">
        <input type="text" name="froms">
        <div class="cut">Your name</div>
      </div>

      <div class="input-container">
        <input type="text" name="title">
        <div class="cut">Note title</div>
      </div>

      <div class="input-container message">
        <textarea name="message" id="" cols="30" rows="10"></textarea>
        <div class="cut">Your message</div>
      </div>


      <input type="submit" value="Submit">
    </form>
  </div>

</body>

</html>

lab_4/templates/lab4_index.html
{% load static %}
<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8" />
  <title>Note list!✨</title>
  <link rel="stylesheet" href="{% static 'css/index.css' %}" />
</head>

<body>

  <ul>
    <li><a href="/lab-4" class="active">Home</a></li>
    <li><a href="/lab-4/add-note">Form</a></li>
    <li><a href="/lab-4/note-list">Card</a></li>
  </ul>

  <div class="container">
    <div class="sub-container">
      <p>Your note list!📝📝</p>
      <table>
        <tr>
          <thead>
            <th>To</th>
            <th>From</th>
            <th>Title</th>
            <th>Message</th>
          </thead>
        </tr>
        {% if notes %}
        {% for note in notes %}
        <tr>
          <td>{{ note.to }}</td>
          <td>{{ note.froms }}</td>
          <td>{{ note.title }}</td>
          <td>{{ note.message }}</td>
        </tr>
        {% endfor %}
        {% endif %}
      </table>
    </div>
  </div>
</body>

</html>

lab_4/templates/lab4_note_list.html
{% load static %}
<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8" />
  <title>Friend List</title>
  <link rel="stylesheet" href="{% static 'css/card.css' %}" />
</head>

<body>

  <ul>
    <li><a href="/lab-4">Home</a></li>
    <li><a href="/lab-4/add-note">Form</a></li>
    <li><a href="/lab-4/note-list" class="active">Card</a></li>
  </ul>


  <div class="container">
    <div class="sub-container">

      {% if notes %}
      {% for note in notes %}
      <div class="card">

        <p class="title">{{ note.title }}</p>

        <p>Untuk: {{ note.to }}</p>
        <p>Dari: {{ note.froms }}</p>
        <br>

        <p class="message">{{ note.message }}</p>

      </div>
      {% endfor %}
      {% endif %}

    </div>
  </div>



</body>

</html>